import { type QueryObject } from 'ufo';
import type { H3Event } from 'h3';
import type { FetchOptions, FetchResponse, FetchError } from 'ofetch';
import type { GraphqlMiddlewareRequestContext, GraphqlMiddlewareRuntimeConfig, GraphqlMiddlewareServerOptions } from './../../../types.js';
import { GraphqlMiddlewareOperation } from './../../settings/index.js';
import { type Operations } from '#graphql-documents';
export declare function queryParamToVariables(query: QueryObject): any;
/**
 * Extract the client context from the query params.
 */
export declare function extractRequestContext(query: QueryObject): GraphqlMiddlewareRequestContext<any>;
/**
 * Get the URL of the GraphQL endpoint.
 */
export declare function getEndpoint(config: GraphqlMiddlewareRuntimeConfig, serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string, context: GraphqlMiddlewareRequestContext<any>): string | Promise<string>;
/**
 * Get the options for the $fetch request to the GraphQL server.
 */
export declare function getFetchOptions(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string, context: GraphqlMiddlewareRequestContext<any>): FetchOptions | Promise<FetchOptions>;
export declare function throwError(statusMessage: string, statusCode?: number): never;
/**
 * Assure that the request is valid.
 */
export declare function validateRequest(method?: string, operation?: GraphqlMiddlewareOperation | string, name?: string, documents?: Operations): void;
/**
 * Handle GraphQL server response.
 */
export declare function onServerResponse(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, response: FetchResponse<any>, operation: string, operationName: string, context: GraphqlMiddlewareRequestContext<any>): any;
/**
 * Handle GraphQL server errors.
 */
export declare function onServerError(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, error: FetchError, operation: string, operationName: string, context: GraphqlMiddlewareRequestContext<any>): any;
